Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 485920 - sys-apps/portage: use dependencies on USE_EXPAND-values broken for binary packages
Summary: sys-apps/portage: use dependencies on USE_EXPAND-values broken for binary pac...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Unspecified (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Portage team
URL:
Whiteboard:
Keywords: InVCS
: 497526 (view as bug list)
Depends on:
Blocks: 484436
  Show dependency tree
 
Reported: 2013-09-25 05:46 UTC by Eugeny Shkrigunov
Modified: 2014-01-08 19:41 UTC (History)
7 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Eugeny Shkrigunov 2013-09-25 05:46:28 UTC
Hi!
Sorry for my English.

Ebuilds >=media-libs/fontconfig-2.10.92 lead to a problem.

The problem in binary packages media-libs/fontconfig-2.10.92 and its dependencies (>=dev-libs/expat-1.95.3[${MULTILIB_USEDEP}] >=media-libs/freetype-2.2.1[${MULTILIB_USEDEP}]).
On a build host these packages builds fine. On a client host binary packages dev-libs/expat and media-libs/freetype are not installs with error:
there are no ebuilds to satisfy ">=dev-libs/expat-1.95.3[abi_x86_64(-),abi_x86_64(-)]"

dev-libs/expat and media-libs/freetype does not have USE-flags abi_*


The build hosts emerge --info

Portage 2.2.1 (default/linux/amd64/13.0, gcc-4.6.3, glibc-2.15-r3, 3.10.7-gentoo-1 x86_64)
=================================================================
System uname: Linux-3.10.7-gentoo-1-x86_64-Intel-R-_Core-TM-_i7-3770_CPU_@_3.40GHz-with-gentoo-2.2
KiB Mem:     7994532 total,    839440 free
KiB Swap:    2097148 total,   2097148 free
Timestamp of tree: Wed, 25 Sep 2013 04:30:01 +0000
ld GNU ld (GNU Binutils) 2.23.1
app-shells/bash:          4.2_p45
dev-java/java-config:     2.1.12-r1
dev-lang/python:          2.7.5-r2, 3.2.5-r2
dev-util/cmake:           2.8.10.2-r2
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.11.8
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.10.3, 1.11.6, 1.12.6, 1.13.4
sys-devel/binutils:       2.23.1
sys-devel/gcc:            4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.9 (virtual/os-headers)
sys-libs/glibc:           2.15-r3
Repositories: gentoo local sunrise science
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA AdobeFlash-11.x dlj-1.1 Oracle-BCLA-JavaSE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=core2 -Os -fomit-frame-pointer -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=core2 -Os -fomit-frame-pointer -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS=" --with-bdeps=y --dynamic-deps=n --autounmask=n"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs buildpkg config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
LANG="ru_RU.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j 4 -l 8"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage/local /var/lib/layman/sunrise /var/lib/layman/science"
USE="X a52 aac acl acpi alsa amd64 amr bash-completion berkdb bzip2 cairo caps cdr cli consolekit cracklib crypt css cups cxx dbus dga dirac dri dvd encode exif fam ffmpeg flac fontconfig gdbm gif gpm gstreamer iconv idn inotify jpeg jpeg2k kerberos lame lcms ldap libnotify lzma matroska mmx mng modules mp3 mpeg multilib ncurses nls nptl ogg opengl openmp pam pcre pdf png policykit postscript pulseaudio qt3support qt4 readline rle scanner schroedinger semantic-desktop session smp spell sse sse2 sse3 ssl ssse3 startup-notification svg tcpd theora threads tiff truetype udev unicode usb v4l vaapi vdpau vim-syntax vnc vorbis vpx x264 xattr xcb xcomposite xpm xv xvid xvmc zlib" ABI_X86="64" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="evdev synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver pdfimport" LINGUAS="ru ru_RU" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_2" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby19 ruby18" SANE_BACKENDS="net pixma xerox_mfp" USERLAND="GNU" VIDEO_CARDS="i915 i965 intel nvidia r300 r600 radeon vesa" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, SYNC, USE_PYTHON


The client hosts emerge --info

Portage 2.2.1 (default/linux/amd64/13.0, gcc-4.6.3, glibc-2.15-r3, 3.10.7-gentoo-1 x86_64)
=================================================================
System uname: Linux-3.10.7-gentoo-1-x86_64-Intel-R-_Core-TM-2_Duo_CPU_E4500_@_2.20GHz-with-gentoo-2.2
KiB Mem:     2041968 total,    967968 free
KiB Swap:    2097148 total,   2097148 free
Timestamp of tree: Wed, 25 Sep 2013 04:39:29 +0000
ld GNU ld (GNU Binutils) 2.23.1
app-shells/bash:          4.2_p45
dev-java/java-config:     2.1.12-r1
dev-lang/python:          2.7.5-r2, 3.2.5-r2
dev-util/cmake:           2.8.10.2-r2
dev-util/pkgconfig:       0.28
sys-apps/baselayout:      2.2
sys-apps/openrc:          0.11.8
sys-apps/sandbox:         2.6-r1
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.10.3, 1.11.6, 1.12.6, 1.13.4
sys-devel/binutils:       2.23.1
sys-devel/gcc:            4.6.3
sys-devel/gcc-config:     1.7.3
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r4
sys-kernel/linux-headers: 3.9 (virtual/os-headers)
sys-libs/glibc:           2.15-r3
Repositories: gentoo local science sunrise
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA AdobeFlash-11.x dlj-1.1 Oracle-BCLA-JavaSE"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-march=core2 -Os -fomit-frame-pointer -pipe"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=core2 -Os -fomit-frame-pointer -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS=" --with-bdeps=y --dynamic-deps=n --autounmask=n"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles getbinpkg merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
LANG="ru_RU.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j 2 -l 2"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage/local /usr/local/portage/science /usr/local/portage/sunrise"
USE="X a52 aac acl acpi alsa amd64 amr bash-completion berkdb bzip2 cairo caps cdr cli consolekit cracklib crypt css cups cxx dbus dga dirac dri dvd encode exif fam ffmpeg flac fontconfig gdbm gif gpm gstreamer iconv idn inotify jpeg jpeg2k kerberos lame lcms ldap libnotify lzma matroska mmx mng modules mp3 mpeg multilib ncurses nls nptl ogg opengl openmp pam pcre pdf png policykit postscript pulseaudio qt3support qt4 readline rle scanner schroedinger semantic-desktop session smp spell sse sse2 sse3 ssl ssse3 startup-notification svg tcpd theora threads tiff truetype udev unicode usb v4l vaapi vdpau vim-syntax vnc vorbis vpx x264 xattr xcb xcomposite xpm xv xvid xvmc zlib" ABI_X86="64" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="*" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="evdev synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver pdfimport" LINGUAS="ru ru_RU" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_2" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby19 ruby18" SANE_BACKENDS="net pixma xerox_mfp" USERLAND="GNU" VIDEO_CARDS="i915 i965 intel nvidia r300 r600 radeon vesa" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS, SYNC, USE_PYTHON
Comment 1 Rafał Mużyło 2013-09-25 09:46:44 UTC
>=expat-2.1.0-r3 and >=freetype-2.4.11-r2 do have those useflags, so likely INVALID.
Comment 2 Eugeny Shkrigunov 2013-09-25 16:49:21 UTC
(In reply to Rafał Mużyło from comment #1)
> >=expat-2.1.0-r3 and >=freetype-2.4.11-r2 do have those useflags, so likely INVALID.

But the current stable (amd64) version is broken.
For media-libs/fontconfig-2.10.92 RDEPEND should be
|| (
       (
            >=dev-libs/expat-1.95.3 <dev-libs/expat-2.1.0-r3
            >=media-libs/freetype-2.2.1 <media-libs/freetype-X.Y.Z
       )
       (
            >=dev-libs/expat-2.1.0-r3[${MULTILIB_USEDEP}]
            >=media-libs/freetype-X.Y.Z[${MULTILIB_USEDEP}]
       )
)
or something like, isnt it
Comment 3 Michał Górny archtester Gentoo Infrastructure gentoo-dev Security 2013-09-26 20:53:37 UTC
This seems to me like trying to install packages from testing on a stable system. Multilib flags are masked on stable currently. I don't know how package.stable.use.mask affects binary packages, though. Maybe dev-portage@ could help.
Comment 4 Eugeny Shkrigunov 2013-10-10 06:33:27 UTC
(In reply to Michał Górny from comment #3)
> This seems to me like trying to install packages from testing on a stable
> system. Multilib flags are masked on stable currently. I don't know how
> package.stable.use.mask affects binary packages, though. Maybe dev-portage@
> could help.

No way - all these packages are stable:
dev-libs/expat-2.1.0-r2
media-libs/fontconfig-2.10.92
media-libs/freetype-2.4.11

Please do anything - with MULTILIB_USEDEP more and more packages concerned.
MULTILIB_USEDEP breaks binary packages at all.
Comment 5 Alexis Ballier gentoo-dev 2013-10-11 11:50:45 UTC
the problem here is not multilib stuff but rather the abi_x86_64 useflag which is enabled and forced for fontconfig (as a consequence of multilib conversion) and thus requires the same flag enabled on freetype and expat, which should thus have been stabilized _before_ fontconfig

I cant believe arch teams stabilized this and that repoman doesnt catch it
Comment 6 Eugeny Shkrigunov 2013-10-11 12:17:12 UTC
(In reply to Alexis Ballier from comment #5)
> the problem here is not multilib stuff but rather the abi_x86_64 useflag
> which is enabled and forced for fontconfig (as a consequence of multilib
> conversion) and thus requires the same flag enabled on freetype and expat,
> which should thus have been stabilized _before_ fontconfig
> 
> I cant believe arch teams stabilized this and that repoman doesnt catch it

but why dependecy (for expat and freetype) is [abi_x86_64(-)] and not [abi_x86_64(+)] on arch amd64?
Comment 7 Eugeny Shkrigunov 2013-10-20 08:56:02 UTC
> but why dependecy (for expat and freetype) is [abi_x86_64(-)] and not
> [abi_x86_64(+)] on arch amd64?

In fact, it did not help.
I tried to change dependency to [abi_x86_64(+)] - binary packages does not install.
There are many packages that have defined default USE dependencies: category/package[use_flasg(-)] and category/package[use_flasg(+)]. All of them (binary) installs as should. Only [abi_x86_64(-)], [abi_x86_64(+)], etc. have trouble.
Comment 8 Eugeny Shkrigunov 2013-12-02 11:08:48 UTC
Today media-libs/audiofile-0.3.6-r1 require >=media-libs/flac-1.2.1[abi_x86_64(-)]. Binary packages (media-libs/audiofile-0.3.6-r1 and media-libs/flac-1.2.1-r3) had been fine build on build host but does not install on destination host.
Seems it is a bug in portage with resolution dependencies like [abi_x86_64(-)].
Portage's binary packages feature is totally broken. Fix it please.
Comment 9 Sebastian Luther (few) 2013-12-02 19:54:59 UTC
Do you have anything in /etc/portage/profiles on either system?

Please post the entries for flac and audiofile in the binhost's Packages file (to be found in $PKGDIR).

Please post the output of:
emerge --ignore-default-opts -pvtK =audiofile-0.3.6-r1 =media-libs/flac-1.2.1-r3
from both systems.
Comment 10 Eugeny Shkrigunov 2013-12-03 05:16:33 UTC
(In reply to Sebastian Luther (few) from comment #9)
> Do you have anything in /etc/portage/profiles on either system?
> 
> Please post the entries for flac and audiofile in the binhost's Packages
> file (to be found in $PKGDIR).
> 
> Please post the output of:
> emerge --ignore-default-opts -pvtK =audiofile-0.3.6-r1
> =media-libs/flac-1.2.1-r3
> from both systems.

No, I have not /etc/portage/profiles.


Packages' entries:

BUILD_TIME: 1385979789
CPV: media-libs/audiofile-0.3.6-r1
DEFINED_PHASES: compile configure install prepare test
DEPEND: >=media-libs/flac-1.2.1[abi_x86_64(-)] virtual/pkgconfig || ( >=sys-devel/automake-1.13:1.13 >=sys-devel/automake-1.14:1.14 ) >=sys-devel/autoconf-2.68 sys-devel/libtool >=sys-apps/coreutils-8.5 app-arch/xz-utils
DESC: An elegant API for accessing audio files
EAPI: 5
IUSE: flac static-libs test abi_x86_32 abi_x86_64 abi_x86_x32 abi_mips_n32 abi_mips_n64 abi_mips_o32
KEYWORDS: ~alpha amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc ~x86 ~amd64-fbsd ~x86-fbsd ~x86-freebsd ~x86-interix ~amd64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~x86-solaris
LICENSE: GPL-2 LGPL-2.1
MD5: 5dd14bc1a66c2ced6d6adb924a4f6602
MTIME: 1385979789
RDEPEND: >=media-libs/flac-1.2.1[abi_x86_64(-)]
SHA1: a80963316d3af80a9b82da0729803bf65bd220df
SIZE: 185688
SLOT: 0/1
USE: abi_x86_64 flac

BUILD_TIME: 1385964539
CPV: media-libs/flac-1.2.1-r3
DEFINED_PHASES: configure install prepare test
DEPEND: >=media-libs/libogg-1.1.3 sys-devel/gettext virtual/pkgconfig || ( >=sys-devel/automake-1.13:1.13 >=sys-devel/automake-1.14:1.14 ) >=sys-devel/autoconf-2.68 sys-devel/libtool
DESC: free lossless audio encoder and decoder
EAPI: 2
IUSE: 3dnow altivec +cxx debug ogg sse static-libs
KEYWORDS: alpha amd64 arm hppa ia64 ~mips ppc ppc64 sh sparc x86 ~x86-fbsd
LICENSE: BSD FDL-1.2 GPL-2 LGPL-2.1
MD5: 350f8a373a81698fe1a3247258a4b0ea
MTIME: 1385964540
RDEPEND: >=media-libs/libogg-1.1.3
SHA1: 240fbb842cebd471230f503e7c40ef9661d3043c
SIZE: 902230
USE: cxx ogg sse


Output of
emerge --ignore-default-opts -pvtK =media-libs/audiofile-0.3.6-r1 =media-libs/flac-1.2.1-r3

##################################################################################################
# build host:
Calculating dependencies... done!
[binary   R    ] media-libs/flac-1.2.1-r3  USE="cxx ogg sse -3dnow (-altivec) -debug -static-libs" 0 kB
[binary   R    ] media-libs/audiofile-0.3.6-r1:0/1  USE="flac -static-libs {-test}" ABI_X86="(64) (-32) (-x32)" 0 kB

Total: 2 packages (2 reinstalls, 2 binaries), Size of downloads: 0 kB

!!! Multiple package instances within a single package slot have been pulled
!!! into the dependency graph, resulting in a slot conflict:

media-libs/flac:0

  (media-libs/flac-1.2.1-r3::gentoo, installed) pulled in by
    >=media-libs/flac-1.2.1[abi_x86_64(-)] required by (media-libs/audiofile-0.3.6-r1::gentoo, binary scheduled for merge)

  (media-libs/flac-1.2.1-r3::gentoo, binary scheduled for merge) pulled in by
    (no parents that aren't satisfied by other packages in this slot)


!!! Enabling --newuse and --update might solve this conflict.
!!! If not, it might help emerge to give a more specific suggestion.

##################################################################################################
# destination host:
Calculating dependencies... done!

emerge: there are no ebuilds to satisfy ">=media-libs/flac-1.2.1[abi_x86_64(-)]".
(dependency required by "media-libs/audiofile-0.3.6-r1" [binary])
(dependency required by "=media-libs/audiofile-0.3.6-r1" [argument])
Comment 11 Sebastian Luther (few) 2013-12-04 22:04:56 UTC
I think there are at least three problems here:

1) abi_x86_* is not in IUSE. This means that at least for EAPI < 5 use dependencies on these packages don't work. 

2) For some reason they still work for installed packages (which seems wrong), but not for binary packages (that's why this bug exists).

3) If the package is EAPI-5 (like media-libs/flac-1.2.1-r5) then it works for both binary and installed packages. But I wonder if this is wrong too, because non of the rules for profile iuse injection apply to ABI_X86 as I read it.
Comment 12 Sebastian Luther (few) 2013-12-05 13:36:01 UTC
(In reply to Sebastian Luther (few) from comment #11)
> I think there are at least three problems here:
> 

I missed that -r5 uses the multilib-build eclass which adds these flag to IUSE.

> 1) abi_x86_* is not in IUSE. This means that at least for EAPI < 5 use
> dependencies on these packages don't work. 
> 
> 2) For some reason they still work for installed packages (which seems
> wrong), but not for binary packages (that's why this bug exists).
I now think these two things are fine as is (except for the binary package behavior).

For use dependencies on packages using the multilib-build eclass everything should work as expected. 

For ebuilds with EAPI < 5 that don't have those flags in IUSE, use dep defaults may not work as expected.

> 
> 3) If the package is EAPI-5 (like media-libs/flac-1.2.1-r5) then it works
> for both binary and installed packages. But I wonder if this is wrong too,
> because non of the rules for profile iuse injection apply to ABI_X86 as I
> read it.
Ignore this one as the package has these flags in IUSE.
Comment 13 Sebastian Luther (few) 2013-12-05 17:39:31 UTC
The binary package behavior is fixed in git. You'll need to re-create the package index on both systems:

rm $PKGDIR/Packages
emaint --fix binhost

http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;h=c08e18723f34cb33a025b7cfa999f03cced9a67b
Comment 14 Eugeny Shkrigunov 2013-12-06 05:55:21 UTC
(In reply to Sebastian Luther (few) from comment #13)
> The binary package behavior is fixed in git. You'll need to re-create the
> package index on both systems:
> 
> rm $PKGDIR/Packages
> emaint --fix binhost
> 
> http://git.overlays.gentoo.org/gitweb/?p=proj/portage.git;a=commit;
> h=c08e18723f34cb33a025b7cfa999f03cced9a67b

Now it works as should. Thank you very much!
Comment 15 Sebastian Luther (few) 2013-12-06 06:03:18 UTC
Please leave it open until the fix is in a release.
Comment 16 Brian Dolbec gentoo-dev 2014-01-06 00:37:44 UTC
Released in sys-apps/portage-2.2.8.
Comment 17 Coacher 2014-01-08 19:41:19 UTC
*** Bug 497526 has been marked as a duplicate of this bug. ***